[bits 32] ; using 32-bit protected mode

; constant definitions
VIDEO_MEMORY equ 0xb8000 ; memory address
;WHITE_ON_BLACK equ 0x0f ; the color byte for each character
WHITE_ON_BLACK equ 0x40 ; the color byte for each character

print_string_pm:
    pusha
    mov edx, VIDEO_MEMORY; edx now has video memory address

print_string_pm_loop:
    mov al, [ebx] ; memory address of char to print
    mov ah, WHITE_ON_BLACK ; attr to print

    cmp al, 0 ; check if end of string
    je print_string_pm_done

    mov [edx], ax ; store character(al) + attribute(ah) in video memory, in that step we have printed the char to screen
    add ebx, 1 ; next char to READ from ebx
    add edx, 2 ; next char to WRITE in video memory position

    jmp print_string_pm_loop

print_string_pm_done:
    popa
    ret
