#define VIDEO_ADDRESS 0xb8000
#define MAX_ROWS 25
#define MAX_COLS 80
#define WHITE_ON_BLACK 0x0f
#define RED_ON_WHITE 0xf4

/* Screen i/o ports */
#define REG_SCREEN_CTRL 0x3d4
#define REG_SCREEN_DATA 0x3d5

/* Public kernel API */
void clear_screen();
int get_offset(int row, int col);
void set_cursor_offset(int offset);
int get_cursor_offset();
int print_char(char character, int row, int col, char attribute_byte);
int get_offset_row(int offset);
int get_offset_col(int offset, int row);
void print_string(char *message, int row, int col);
int handle_scrolling(int cursor_offset);
