#include "../drivers/screen.h"
#include "util.h"

#include "irqs.h"
#include "isrs.h"

void main() {
    clear_screen();
    print_string("Welcome to MercuryOS v0.1b by Kr0m\n", 0, 0);
    print_string("\n", -1, -1);
    
    print_string(">> Remapping and masking all IRQs\n", -1, -1);
    remap_irqs();
    print_string("Done\n", -1, -1);
    
    print_string(">> Installing ISRs and setting idtr register to IDT table descriptor\n", -1, -1);
    isr_install();
    print_string("Done\n", -1, -1);
    
    print_string(">> Unmasking Keyboard IRQ\n", -1, -1);
    unmask_irq(1);
    print_string("Done\n", -1, -1);
    
    print_string(">> Enabling interrupts: 32 bits protected mode jump disabled it\n", -1, -1);
    enable_interrupts();
    print_string("Done\n", -1, -1);
    
    print_string(">> Generating test interrupts\n", -1, -1);
    /* Test the interrupts */
    print_string("--------------------------------\n", -1, -1);
    __asm__ __volatile__("int $2");
    __asm__ __volatile__("int $3");
    //__asm__ __volatile__("int $33");
    
    print_string(">> Press any key to test IRQ1 keyboard interruption\n", -1, -1);
}


